/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package View;

import javax.swing.JInternalFrame;
import Container.EntityContainer;
import Model.IdiomsModel;
import java.awt.Image;
import java.util.LinkedList;
import javax.swing.DefaultCellEditor;
import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

public class EditEntityTipe extends javax.swing.JDialog {

    JInternalFrame jifLienso = new JInternalFrame();
    EntityContainer E_C;
    IdiomsModel I_M;
    private String ENTITY_TIPE;

    private LinkedList LIST_EDIT, EDIT_FK_LIST;
    private int LIST_POSITION;
    private int CONTADOR_FK;
    private String ENTITY_AFTER_NAME;
    private int DIFERENCIADOR;
    private int POSITION_BEFORE;
    
    public EditEntityTipe(javax.swing.JDialog parent, boolean modal, String entityTipe, IdiomsModel idiomsModel, EntityContainer entityContainer, int contadorEntidad) {
        super(parent, modal);
        this.I_M = idiomsModel;
        this.E_C = entityContainer;
        this.ENTITY_TIPE = entityTipe;
        this.DIFERENCIADOR = contadorEntidad;
        this.setTitle("Tipo-Entidad("+entityTipe+")");
        initComponents();
        Image icon = new ImageIcon(getClass().getResource("/Images/entidad.gif")).getImage();
        this.setIconImage(icon);
        initTiposDeDatos();
        rellenarCamposTabla();
    }
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        JBTTN_ACEPTAR = new javax.swing.JButton();
        JBTTN_CANCELAR = new javax.swing.JButton();
        JTF_ENTITY_NAME = new javax.swing.JTextField();
        JBTTN_BORRARFILA = new javax.swing.JButton();
        JBTTN_AGREGARFILA = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setAutoRequestFocus(false);
        setIconImage(null);

        jTable.setAutoCreateRowSorter(true);
        jTable.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null,  new Boolean(false)},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Atributos", "Tipo de Dato", "PK", "NoNull", "AI"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.Boolean.class, java.lang.Boolean.class, java.lang.Boolean.class
            };
            boolean[] canEdit = new boolean [] {
                true, true, false, true, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jTable.setRowHeight(22);
        jTable.getTableHeader().setReorderingAllowed(false);
        jScrollPane1.setViewportView(jTable);
        if (jTable.getColumnModel().getColumnCount() > 0) {
            jTable.getColumnModel().getColumn(0).setResizable(false);
            jTable.getColumnModel().getColumn(1).setResizable(false);
            jTable.getColumnModel().getColumn(2).setResizable(false);
            jTable.getColumnModel().getColumn(3).setResizable(false);
            jTable.getColumnModel().getColumn(4).setResizable(false);
        }

        jLabel1.setText("Nombre de la Entidad : ");

        JBTTN_ACEPTAR.setText("Aceptar");
        JBTTN_ACEPTAR.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBTTN_ACEPTARActionPerformed(evt);
            }
        });

        JBTTN_CANCELAR.setText("Cancelar");
        JBTTN_CANCELAR.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBTTN_CANCELARActionPerformed(evt);
            }
        });

        JBTTN_BORRARFILA.setText("Borrar fila");
        JBTTN_BORRARFILA.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBTTN_BORRARFILAActionPerformed(evt);
            }
        });

        JBTTN_AGREGARFILA.setText("Agregar fila");
        JBTTN_AGREGARFILA.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBTTN_AGREGARFILAActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(JBTTN_BORRARFILA, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(JBTTN_AGREGARFILA, javax.swing.GroupLayout.PREFERRED_SIZE, 127, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(JBTTN_ACEPTAR)
                        .addGap(18, 18, 18)
                        .addComponent(JBTTN_CANCELAR))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 721, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(JTF_ENTITY_NAME, javax.swing.GroupLayout.PREFERRED_SIZE, 281, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JTF_ENTITY_NAME, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 218, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(JBTTN_CANCELAR)
                            .addComponent(JBTTN_ACEPTAR)))
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(JBTTN_BORRARFILA)
                            .addComponent(JBTTN_AGREGARFILA))))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void JBTTN_ACEPTARActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBTTN_ACEPTARActionPerformed
        if (evt.getSource() == JBTTN_ACEPTAR) {
            boolean estadoM = editarEntidad();
            if (estadoM == false) {
                this.dispose();
            }
        }       
    }//GEN-LAST:event_JBTTN_ACEPTARActionPerformed

    private void JBTTN_CANCELARActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBTTN_CANCELARActionPerformed
        if (evt.getSource() == JBTTN_CANCELAR) {
            this.dispose();
        }
    }//GEN-LAST:event_JBTTN_CANCELARActionPerformed

    private void JBTTN_BORRARFILAActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBTTN_BORRARFILAActionPerformed
        if (evt.getSource() == JBTTN_BORRARFILA) {
            DefaultTableModel dtModel = (DefaultTableModel) this.jTable.getModel();
            try {
                int numeroFila = this.jTable.getSelectedRow();
                boolean estadoPK = (boolean) this.jTable.getValueAt(numeroFila, 2);
                if (estadoPK == false) {
                    dtModel.removeRow(numeroFila);
                } else {
                    JOptionPane.showMessageDialog(rootPane, "No se puede borrar este atributo");
                }
            } catch (ArrayIndexOutOfBoundsException aIE) {
            }
        }
    }//GEN-LAST:event_JBTTN_BORRARFILAActionPerformed

    private void JBTTN_AGREGARFILAActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_JBTTN_AGREGARFILAActionPerformed
        if (evt.getSource() == JBTTN_AGREGARFILA) {
            DefaultTableModel dtModel = (DefaultTableModel) this.jTable.getModel();
            dtModel.addRow(new Object[]{"", "", null, null, null});
        }
    }//GEN-LAST:event_JBTTN_AGREGARFILAActionPerformed

    /**
     * @param args the command line arguments
     */
 

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton JBTTN_ACEPTAR;
    private javax.swing.JButton JBTTN_AGREGARFILA;
    private javax.swing.JButton JBTTN_BORRARFILA;
    private javax.swing.JButton JBTTN_CANCELAR;
    private javax.swing.JTextField JTF_ENTITY_NAME;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    public javax.swing.JTable jTable;
    // End of variables declaration//GEN-END:variables

    private void initTiposDeDatos() {
        TableColumn column1 = this.jTable.getColumnModel().getColumn(1);
        String opciones[] = {"INTEGER", "FLOAT", "DOUBLE", "DECIMAL", "BOOLEAN", "DATE", "DATETIME", "TIME", "YEAR", "TEXT", "CHAR", "VARCHAR(20)", "VARCHAR(45)", "VARCHAR(60)", "VARCHAR(120)", "VARCHAR(220)"};
        JComboBox tipos = new JComboBox(opciones);
        column1.setCellEditor(new DefaultCellEditor(tipos));
    }

    private void rellenarCamposTabla() {
        LinkedList listEntity = new LinkedList();
        LinkedList listFK = new LinkedList();
        String nameEntity = "";
        if (this.ENTITY_TIPE.equals("Maestro")) {
            listEntity = (LinkedList) this.E_C.getMaestro();
            listFK = (LinkedList) this.E_C.getMLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityMaestro();
            rellenarTabla(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("Detalle")) {
            listEntity = (LinkedList) this.E_C.getDetalle();
            listFK = (LinkedList) this.E_C.getDLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityDetalle();
            rellenarTabla(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("Clasificador")) {
            listEntity = (LinkedList) this.E_C.getClasificador();
            listFK = (LinkedList) this.E_C.getCORLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityClasificador();
            rellenarTabla(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("Clasificado")) {
            listEntity = (LinkedList) this.E_C.getClasificado();
            listFK = (LinkedList) this.E_C.getCDOLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityClasificado();
            rellenarTabla(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("Composicion")) {
            listEntity = (LinkedList) this.E_C.getComposicion();
            listFK = (LinkedList) this.E_C.getCLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityComposicion();
            rellenarTablaISACOMPOSICION(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("Componedor")) {
            listEntity = (LinkedList) this.E_C.getComponedor();
            listFK = (LinkedList) this.E_C.getCCLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityComponedor();
            rellenarTabla(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("Componedor1")) {
            listEntity = (LinkedList) this.E_C.getComponedor();
            listFK = (LinkedList) this.E_C.getCCLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityComponedor1();
            rellenarTabla(listEntity,listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("General")) {
            listEntity = (LinkedList) this.E_C.getGeneral();
            listFK = (LinkedList) this.E_C.getGLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityGeneral();
            rellenarTabla(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("Isa")) {
            listEntity = (LinkedList) this.E_C.getIsa();
            listFK = (LinkedList) this.E_C.getILlaveSegundaria();
            nameEntity = this.I_M.getNameEntityIsa();
            rellenarTablaISACOMPOSICION(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("RSimple")) {
            listEntity = (LinkedList) this.E_C.getRSimple();
            listFK = (LinkedList) this.E_C.getRSLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityRSimple();
            rellenarTabla(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("Actor")) {
            listEntity = (LinkedList) this.E_C.getActor();
            listFK = (LinkedList) this.E_C.getALlaveSegundaria();
            nameEntity = this.I_M.getNameEntityActor();
            rellenarTabla(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("Historia")) {
            listEntity = (LinkedList) this.E_C.getHistoria();
            listFK = (LinkedList) this.E_C.getHLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityHistoria();
            rellenarTabla(listEntity, listFK, nameEntity);
        }
        if (this.ENTITY_TIPE.equals("Basico")) {
            listEntity = (LinkedList) this.E_C.getBasico();
            listFK = (LinkedList) this.E_C.getBLlaveSegundaria();
            nameEntity = this.I_M.getNameEntityBasico();
            rellenarTabla(listEntity, listFK, nameEntity);
        }
        this.ENTITY_AFTER_NAME = nameEntity;
    }

    private void rellenarTablaISACOMPOSICION(LinkedList listEntity, LinkedList listFK, String nameEntity) {
        this.JTF_ENTITY_NAME.setText(nameEntity);
        int positionEntity = buscarPosicionEntidad(nameEntity, listEntity);
        this.POSITION_BEFORE = positionEntity;
        LinkedList myList = (LinkedList) listEntity.get(positionEntity);
        this.LIST_EDIT = myList;
        LinkedList myAttributesList = (LinkedList) myList.get(1);
        boolean estateFK = true;
        int numberAux = 0;
        if (0 != myAttributesList.size()) {
            for (int i = 0; i < (myAttributesList.size() / 5); i++) {
                if (estateFK) {
                    numberAux = rellenarCamposFKISACOMPOSICION(listFK, nameEntity);
                    this.CONTADOR_FK = numberAux;
                    estateFK = false;
                }
                int numberInitial = (i * 5);
                int numberEnd = (5 * (i + 1));               
                for (int j = numberInitial; j < numberEnd; j++) {
                    String valueAttribute = (String) myAttributesList.get(j);
                    System.out.println("VALOR DEL ATRIBUTO: "+ valueAttribute);
                    if (valueAttribute.equals("true")) {
                        this.jTable.setValueAt(true, (i + numberAux), (j - numberInitial));
                    } else if (valueAttribute.equals("false")) {
                        this.jTable.setValueAt(false, (i + numberAux), (j - numberInitial));
                    } else {
                        this.jTable.setValueAt(valueAttribute, (i + numberAux), (j - numberInitial));
                    }
                }       
            }
        } else {
            numberAux = rellenarCamposFKISACOMPOSICION(listFK, nameEntity);
            this.CONTADOR_FK = numberAux;
            estateFK = true;
        }
    }
    
    private void rellenarTabla(LinkedList listEntity, LinkedList listFK, String nameEntity) {
        this.JTF_ENTITY_NAME.setText(nameEntity);
        int positionEntity = buscarPosicionEntidad(nameEntity, listEntity);
        this.POSITION_BEFORE = positionEntity;
        LinkedList myList = (LinkedList) listEntity.get(positionEntity);
        this.LIST_EDIT = myList;
        LinkedList myAttributesList = (LinkedList) myList.get(1);
        boolean estateFK = true;
        int numberAux = 0;
        for (int i = 0; i < (myAttributesList.size() / 5); i++) {
            int numberInitial = (i * 5);
            int numberEnd = (5 * (i + 1));
            for (int j = numberInitial; j < numberEnd; j++) {
                String valueAttribute = (String) myAttributesList.get(j);
                System.out.println("VALOR DEL ATRIBUTO: " + valueAttribute);
                if (valueAttribute.equals("true")) {
                    this.jTable.setValueAt(true, (i + numberAux), (j - numberInitial));
                } else if (valueAttribute.equals("false")) {
                    this.jTable.setValueAt(false, (i + numberAux), (j - numberInitial));
                } else {
                    this.jTable.setValueAt(valueAttribute, (i + numberAux), (j - numberInitial));
                }
            }
            if (estateFK) {
                numberAux = rellenarCamposFK(listFK, nameEntity);
                this.CONTADOR_FK = numberAux;
                estateFK = false;
            }
        }
    }

    private int buscarPosicionEntidad(String nameE,LinkedList list) {
        int res = -1;
        for (int i = 0; i < list.size(); i++) {
            LinkedList listAux = (LinkedList) list.get(i);
            String entityName = (String) listAux.get(0); 
            if (entityName.equals(nameE)) {
                res = i;
            }
        }
        return res;
    }

    private int rellenarCamposFKISACOMPOSICION(LinkedList listFK, String nameEntity) {
        int aux = 0;
        for (int i = 0; i < listFK.size(); i++) {
            LinkedList myList = (LinkedList) listFK.get(i);
            String nameTipeFK = (String) myList.get(2);
            String nameEntityFK = (String) myList.get(4);
            if (nameEntity.equals(nameEntityFK)) {
                if (!nameTipeFK.equals("Clasificador") && !nameTipeFK.equals("RSimple")) {
                    if (!this.ENTITY_TIPE.equals("Clasificado") && !this.ENTITY_TIPE.equals("RSimple")) {
                        this.EDIT_FK_LIST = myList;
                        String nameAttribute = (String) myList.get(3);
                        this.jTable.setValueAt(nameAttribute, (aux), 0);
                        this.jTable.setValueAt("INTEGER", (aux), 1);
                        this.jTable.setValueAt(true, (aux), 2);
                        this.jTable.setValueAt(true, (aux), 3);
                        this.jTable.setValueAt(false, (aux), 4);
                        aux = aux + 1;
                    } else {
                        this.EDIT_FK_LIST = myList;
                        String nameAttribute = (String) myList.get(3);
                        this.jTable.setValueAt(nameAttribute, (aux), 0);
                        this.jTable.setValueAt("INTEGER", (aux), 1);
                        this.jTable.setValueAt(false, (aux), 2);
                        this.jTable.setValueAt(true, (aux), 3);
                        this.jTable.setValueAt(false, (aux), 4);
                        aux = aux + 1;
                    }
                } else {
                    this.EDIT_FK_LIST = myList;
                    String nameAttribute = (String) myList.get(3);
                    this.jTable.setValueAt(nameAttribute, (aux), 0);
                    this.jTable.setValueAt("INTEGER", (aux), 1);
                    this.jTable.setValueAt(false, (aux), 2);
                    this.jTable.setValueAt(true, (aux), 3);
                    this.jTable.setValueAt(false, (aux), 4);
                    aux = aux + 1;
                }
            }
        }
        return aux;
    }
        
    private int rellenarCamposFK(LinkedList listFK, String nameEntity) {
        int aux = 0;
        for (int i = 0; i < listFK.size(); i++) {
            LinkedList myList = (LinkedList) listFK.get(i);
            String nameTipeFK = (String) myList.get(2);
            String nameEntityFK = (String) myList.get(4);
            if (nameEntity.equals(nameEntityFK)) {
                if (!nameTipeFK.equals("Clasificador") && !nameTipeFK.equals("RSimple")) {
                    if (!this.ENTITY_TIPE.equals("Clasificado") && !this.ENTITY_TIPE.equals("RSimple")) {
                        this.EDIT_FK_LIST = myList;
                        String nameAttribute = (String) myList.get(3);
                        this.jTable.setValueAt(nameAttribute, (aux + 1), 0);
                        this.jTable.setValueAt("INTEGER", (aux + 1), 1);
                        this.jTable.setValueAt(true, (aux + 1), 2);
                        this.jTable.setValueAt(true, (aux + 1), 3);
                        this.jTable.setValueAt(false, (aux + 1), 4);
                        aux = aux + 1;
                    } else {
                        this.EDIT_FK_LIST = myList;
                        String nameAttribute = (String) myList.get(3);
                        this.jTable.setValueAt(nameAttribute, (aux + 1), 0);
                        this.jTable.setValueAt("INTEGER", (aux + 1), 1);
                        this.jTable.setValueAt(false, (aux + 1), 2);
                        this.jTable.setValueAt(true, (aux + 1), 3);
                        this.jTable.setValueAt(false, (aux + 1), 4);
                        aux = aux + 1;
                    }
                } else {
                    this.EDIT_FK_LIST = myList;
                    String nameAttribute = (String) myList.get(3);
                    this.jTable.setValueAt(nameAttribute, (aux + 1), 0);
                    this.jTable.setValueAt("INTEGER", (aux + 1), 1);
                    this.jTable.setValueAt(false, (aux + 1), 2);
                    this.jTable.setValueAt(true, (aux + 1), 3);
                    this.jTable.setValueAt(false, (aux + 1), 4);
                    aux = aux + 1;
                }
            }
        }
        return aux;
    }

    private boolean editarEntidad() {
        boolean aux = false;
        try {
            String entityName = this.JTF_ENTITY_NAME.getText();
            if (this.ENTITY_TIPE.equals("Maestro")) {
                int posEntity = 0;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un tipo de entidad con el mismo nombre");
                    aux = true;
//                    String newName = entityName + "_" + this.DIFERENCIADOR;
//                    this.I_M.setEntityMaestroName(newName);
//                    this.LIST_EDIT.set(0, newName);
//                    this.LIST_EDIT.remove(1);
//                    this.LIST_EDIT.add(editarAtributos());
//                    editarListaFK(this.ENTITY_AFTER_NAME, newName, (String) this.jTable.getValueAt(0, 0));
                } else {
                    this.I_M.setEntityMaestroName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("Detalle")) {
                int posEntity = 1;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityDetalleName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("Clasificador")) {
                int posEntity = 2;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityClasificadorName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("Clasificado")) {
                int posEntity = 3;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityClasificadoName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("Composicion")) {
                int posEntity = 4;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityComposicionName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributosISACOMPOSICION());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("Componedor")) {
                int posEntity = 5;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityComponedorName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("Componedor1")) {
                int posEntity = 5;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityComponedor1Name(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("General")) {
                int posEntity = 6;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityGeneralName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("Isa")) {
                int posEntity = 7;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityIsaName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributosISACOMPOSICION());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("RSimple")) {

                int posEntity = 8;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityRSimpleName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }

            }
            if (this.ENTITY_TIPE.equals("Actor")) {
                int posEntity = 9;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityActorName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("Historia")) {
                int posEntity = 10;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityHistoriaName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
            if (this.ENTITY_TIPE.equals("Basico")) {
                int posEntity = 11;
                if (existeNombreEntidad(entityName, posEntity)) {
                    JOptionPane.showMessageDialog(rootPane, "Existe un Tipo de Entidad con el mismo nombre");
                    aux = true;
                } else {
                    this.I_M.setEntityBasicoName(entityName);
                    this.LIST_EDIT.set(0, entityName);
                    this.LIST_EDIT.remove(1);
                    this.LIST_EDIT.add(editarAtributos());
                    editarListaFK(this.ENTITY_AFTER_NAME, entityName, (String) this.jTable.getValueAt(0, 0));
                }
            }
        } catch (Exception e) {
            JOptionPane.showMessageDialog(rootPane, "Error al editar el tipo de entidad, intentar de nuevo");
        }
        return aux;
    }
    private LinkedList editarAtributosISACOMPOSICION() {
        LinkedList myAuxList = new LinkedList();
        int auxNumber = this.CONTADOR_FK;;
        int rowCount = this.jTable.getRowCount();
        for (int i = 0; i < (rowCount - auxNumber); i++) {
            if (this.jTable.getValueAt(i + auxNumber, 0) != null && this.jTable.getValueAt(i + auxNumber, 1) != null) {
                String attributeName = (String) this.jTable.getValueAt(i + auxNumber, 0);
                String dateTipeName = (String) this.jTable.getValueAt(i + auxNumber, 1);
                boolean statePK = false;
                if(this.jTable.getValueAt(i + auxNumber, 2) != null){
                   statePK = (boolean) this.jTable.getValueAt(i + auxNumber, 2);
                }
                boolean stateNoNull = false;
                if(this.jTable.getValueAt(i + auxNumber, 3) != null){
                    stateNoNull = (boolean) this.jTable.getValueAt(i + auxNumber, 3);
                }
                boolean stateAI = false;
                if(this.jTable.getValueAt(i + auxNumber, 4) != null){
                    stateAI = (boolean) this.jTable.getValueAt(i + auxNumber, 4);
                }
                if (existeNombreAtributo(attributeName, myAuxList)) {
                    String newAttributeName = attributeName+"_"+i;
                    myAuxList.add(newAttributeName);
                } else {
                    myAuxList.add(attributeName);
                }
                myAuxList.add(dateTipeName);
                if (statePK) {
                    myAuxList.add("true");
                } else {
                    myAuxList.add("false");
                }
                if (stateNoNull) {
                    myAuxList.add("true");
                } else {
                    myAuxList.add("false");
                }
                if (stateAI) {
                    myAuxList.add("true");
                } else {
                    myAuxList.add("false");
                }
            }
            auxNumber = this.CONTADOR_FK;
        }
        return myAuxList;
    }
    
    private LinkedList editarAtributos() {
        LinkedList myAuxList = new LinkedList();
        int auxNumber = 0;
        int rowCount = this.jTable.getRowCount();
        for (int i = 0; i < (rowCount - auxNumber); i++) {
            if (this.jTable.getValueAt(i + auxNumber, 0) != null && this.jTable.getValueAt(i + auxNumber, 1) != null) {
                String attributeName = (String) this.jTable.getValueAt(i + auxNumber, 0);
                String dateTipeName = (String) this.jTable.getValueAt(i + auxNumber, 1);
                boolean statePK = false;
                if(this.jTable.getValueAt(i + auxNumber, 2) != null){
                   statePK = (boolean) this.jTable.getValueAt(i + auxNumber, 2);
                }
                boolean stateNoNull = false;
                if(this.jTable.getValueAt(i + auxNumber, 3) != null){
                    stateNoNull = (boolean) this.jTable.getValueAt(i + auxNumber, 3);
                }
                boolean stateAI = false;
                if(this.jTable.getValueAt(i + auxNumber, 4) != null){
                    stateAI = (boolean) this.jTable.getValueAt(i + auxNumber, 4);
                }
                if (existeNombreAtributo(attributeName, myAuxList)) {
                    String newAttributeName = attributeName+"_"+i;
                    myAuxList.add(newAttributeName);
                } else {
                    myAuxList.add(attributeName);
                }
                myAuxList.add(dateTipeName);
                if (statePK) {
                    myAuxList.add("true");
                } else {
                    myAuxList.add("false");
                }
                if (stateNoNull) {
                    myAuxList.add("true");
                } else {
                    myAuxList.add("false");
                }
                if (stateAI) {
                    myAuxList.add("true");
                } else {
                    myAuxList.add("false");
                }
            }
            auxNumber = this.CONTADOR_FK;
        }
        return myAuxList;
    }

    private void editarListaFK(String entityAfterName, String entityName, String attributeName) {
        LinkedList fKsList = new LinkedList();
        fKsList.add((LinkedList) this.E_C.getMLlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getDLlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getCORLlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getCDOLlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getCLlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getCCLlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getGLlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getILlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getRSLlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getALlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getHLlaveSegundaria());
        fKsList.add((LinkedList) this.E_C.getBLlaveSegundaria());
        for (int i = 0; i < fKsList.size(); i++) {
            eliminarAgregarFK(entityAfterName, entityName, attributeName, (LinkedList) fKsList.get(i));
        }
    }

    private void eliminarAgregarFK(String entityAfterName, String entityName, String attributeName, LinkedList editFKsList) {
        for (int i = 0; i < editFKsList.size(); i++) {
            LinkedList myAuxList = (LinkedList) editFKsList.get(i);
            String initialAttributeName = (String) myAuxList.get(0);
            String endAttributeName = (String) myAuxList.get(4);
            if (initialAttributeName.equals(entityAfterName)) {
                editFKsList.remove(i);
            } else if (endAttributeName.equals(entityAfterName)) {
                myAuxList.set(4, entityName);
            } else {
                System.out.println("NO EXISTE TAL LLAVE SEGUNDARIA");
            }
        }
    }

    private boolean existeNombreEntidad(String entityName, int position) {
        boolean res = false;
        LinkedList idiomsList = idiomsList();
        for (int i = 0; i < idiomsList.size(); i++) {
            if (i != position) {
                LinkedList idiomList = (LinkedList) idiomsList.get(i);
                for (int j = 0; j < idiomList.size(); j++) {
                    LinkedList entityList = (LinkedList) idiomList.get(j);
                    String entityNameList = (String) entityList.get(0);
                    if (entityName.equals(entityNameList)) {
                        res = true;
                    }
                }
            } else {
                LinkedList idiomList = (LinkedList) idiomsList.get(i);
                int positionEntity = this.POSITION_BEFORE;
                for (int j = 0; j < idiomList.size(); j++) {
                    if (j != positionEntity) {
                        LinkedList myAuxList = (LinkedList) idiomList.get(j);
                        String entityNameList = (String) myAuxList.get(0);
                        if (entityName.equals(entityNameList)) {
                            res = true;
                        }
                    }
                }
            }
        }
        return res;
    }

    private boolean existeNombreAtributo(String attributeName, LinkedList myAuxList) {
        boolean res = false;
        for (int i = 0; i < myAuxList.size(); i = i + 5) {
            String attributeNameList = (String) myAuxList.get(i);
            if (attributeName.equals(attributeNameList)) {
                res = true;
            }
        }
        return res;
    }

    private LinkedList idiomsList() {
        LinkedList list = new LinkedList();
        list.add((LinkedList) this.E_C.getMaestro());//0
        list.add((LinkedList) this.E_C.getDetalle());//1
        list.add((LinkedList) this.E_C.getClasificador());//2
        list.add((LinkedList) this.E_C.getClasificado());//3
        list.add((LinkedList) this.E_C.getComposicion());//4
        list.add((LinkedList) this.E_C.getComponedor());//5
        list.add((LinkedList) this.E_C.getGeneral());//6
        list.add((LinkedList) this.E_C.getIsa());//7
        list.add((LinkedList) this.E_C.getRSimple());//8
        list.add((LinkedList) this.E_C.getActor());//9
        list.add((LinkedList) this.E_C.getHistoria());//10
        list.add((LinkedList) this.E_C.getBasico());//11
        return list;
    }
}
